/* "Image Tool"
 * Copyright (C) 2000-01 by Next Generation
 * Written by Chris Hansen.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * NEXT GENERATION on the Web: www.nextgeneration.dk
 * CONTACT: info@nextgeneration.dk
 */

#define WIN32_LEAN_AND_MEAN 1
#include <windows.h>

void
RunRawrite (LPPROCESS_INFORMATION lppi, HWND hEditInfo, char *psExeDir, char *psFullFileName, char *psDestDrive)
{
  DWORD dwBytesRead;
  HANDLE hErrorWrite, hInputRead, hInputWrite, hInputWriteTmp, hOutputRead, hOutputReadTmp, hOutputWrite;
  LONG nBytesToRead;
  PBYTE pBuffer;
  SECURITY_ATTRIBUTES sa;
  STARTUPINFO si;
  TCHAR sCommand[MAX_PATH];
  
  wsprintf (sCommand, "%s\\RAWRITE.EXE -n -f %s -d %s", psExeDir, psFullFileName, psDestDrive);

  sa.nLength = sizeof (SECURITY_ATTRIBUTES);
  sa.lpSecurityDescriptor = NULL;
  sa.bInheritHandle = TRUE;

  CreatePipe (hOutputReadTmp, hOutputWrite, &sa, 0);
  DuplicateHandle (GetCurrentProcess (), hOutputWrite, GetCurrentProcess (), &hErrorWrite, 0, TRUE, DUPLICATE_SAME_ACCESS);
  CreatePipe (hInputRead, hInputWriteTmp, &sa, 0);
  DuplicateHandle(GetCurrentProcess (), hOutputReadTmp,  GetCurrentProcess (), &hOutputRead,  0, FALSE, DUPLICATE_SAME_ACCESS);
  DuplicateHandle(GetCurrentProcess (), hInputWriteTmp, GetCurrentProcess (), &hInputWrite, 0, FALSE, DUPLICATE_SAME_ACCESS);
  CloseHandle (hOutputReadTmp);
  CloseHandle (hInputWriteTmp);

  ZeroMemory (&si, sizeof (STARTUPINFO));
  si.cb = sizeof (STARTUPINFO);
  si.dwFlags = STARTF_USESTDHANDLES | STARTF_USESHOWWINDOW;
  si.hStdInput = hInputRead;
  si.hStdOutput = hOutputWrite;
  si.hStdError = hErrorWrite;
  si.wShowWindow = SW_HIDE;
  
  CreateProcess (NULL, sCommand, &sa, &sa, TRUE, 0, NULL, NULL, &si, lppi);
  CloseHandle (hOutputWrite);
  CloseHandle (hInputRead);
  CloseHandle (hErrorWrite);

  nBytesToRead = GetFileSize (hOutputRead, NULL);
  pBuffer = (PBYTE) HeapAlloc (GetProcessHeap (), 0, nBytesToRead + 2);

  ReadFile (hOutputRead, pBuffer, nBytesToRead, &dwBytesRead, NULL);
  pBuffer[dwBytesRead] = '\0';
  SetWindowText (hEditInfo, pBuffer);

  HeapFree (GetProcessHeap (), 0, pBuffer);

  return;
}