/* "Image Tool"
 * Copyright (C) 2000-01 by Next Generation
 * Written by Chris Hansen.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * NEXT GENERATION on the Web: www.nextgeneration.dk
 * CONTACT: info@nextgeneration.dk
 */

#define WIN32_LEAN_AND_MEAN 1
#include <windows.h>
#include <commdlg.h>

static OPENFILENAME ofn;
static char sFileFilter[] = "Image Files (*.img)\0*.img\0All Files (*.*)\0*.*\0\0";

BOOL
SelectFile (HWND hwnd, char *psTitleName, char *psCurrentDir)
{
  ofn.lStructSize = sizeof (OPENFILENAME);
  ofn.hwndOwner = hwnd;
  ofn.hInstance = NULL;
  ofn.lpstrFilter = sFileFilter;
  ofn.lpstrCustomFilter = NULL;
  ofn.nMaxCustFilter = 0;
  ofn.nFilterIndex = 1;
  ofn.lpstrFile = psTitleName;
  ofn.nMaxFile = MAX_PATH;
  ofn.lpstrFileTitle = psTitleName;
  ofn.nMaxFileTitle = MAX_PATH;
  ofn.lpstrInitialDir = psCurrentDir;
  ofn.lpstrTitle = NULL;
  ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST;
  ofn.nFileOffset = 0;
  ofn.nFileExtension = 0;
  ofn.lpstrDefExt = "img";
  ofn.lCustData = 0L;
  ofn.lpfnHook = NULL;
  ofn.lpTemplateName = NULL;

  return GetOpenFileName (&ofn);
}

